local addon = CCAssign
if not addon then return end
local L = LibStub("AceLocale-3.0"):GetLocale("CCAssign")
addon.defaults = {profile={
	mode=0,
	modes={
		[0]={
			stickCursor=true,
		},
	},
}}
local binding_updates = {
	[0]={r=function() SetBinding(addon.opt.binding, "CCASSIGN_SHOW") end, u=function() SetBinding("", "CCASSIGN_SHOW") end,},
	[1]={r=function() addon:BindRing(addon.opt.binding) end, u=function() addon:BindRing(false) end,},
}
local support_addon = {
	OPie={t=L["OPie plugin mode"],n=1,},
}
local stylevalues = {
	[0]=L["Standalone mode"],
}
for addon, data in pairs(support_addon) do
	if IsAddOnLoaded(addon) then
		stylevalues[data.n]=data.t
	end
end
function addon:OnProfileEnable()
end
addon.options = {
	type="group",
	args={
		button={
			type="group",
			name=L["Button settings"],
			args={
				select={
					name=L["Style of display"],
					desc=L["Whether CCAssign should plug into any other addon or use its own stand-alone display"],
					type="select",
					order=1,
					set=function(i,value) binding_updates[addon.opt.mode].u() addon.opt.mode = value binding_updates[value].r() end,
					get=function() return addon.opt.mode end,
					style="dropdown",
					values=stylevalues,
				},
			},
			order=1,
		},
		keybinds={
			type="keybinding",
			name=L["Show keybind"],
			get=function() return addon.opt.binding end,
			set=function(info, value) addon.opt.binding = value binding_updates[addon.opt.mode].u() binding_updates[addon.opt.mode].r() end,
			order=1,
		},
	}
}