local _G = _G
local tostring, pairs, type, setmetatable, tinsert, table, ipairs, collectgarbage, tremove, math, select, print =
	  tostring, pairs, type, setmetatable, tinsert, table, ipairs, collectgarbage, tremove, math, select, print
local UnitExists, UnitName, UnitIsEnemy, UnitCreatureType, UnitClass, UnitLevel, GetSpellInfo, SendChatMessage, SetRaidTarget, GetNumRaidMembers, GetNumPartyMembers, IsControlKeyDown =
	  UnitExists, UnitName, UnitIsEnemy, UnitCreatureType, UnitClass, UnitLevel, GetSpellInfo, SendChatMessage, SetRaidTarget, GetNumRaidMembers, GetNumPartyMembers, IsControlKeyDown
local RAID_TARGET_1, RAID_TARGET_2, RAID_TARGET_3, RAID_TARGET_4, RAID_TARGET_5, RAID_TARGET_6, RAID_TARGET_7, RAID_TARGET_8 =
	  RAID_TARGET_1, RAID_TARGET_2, RAID_TARGET_3, RAID_TARGET_4, RAID_TARGET_5, RAID_TARGET_6, RAID_TARGET_7, RAID_TARGET_8

--[[
/run local x,y = GetCursorPosition() local rX,rY = (UIParent:GetWidth()/WorldFrame:GetWidth()),(UIParent:GetHeight()/WorldFrame:GetHeight()) ASDF:ClearAllPoints() ASDF:SetPoint("CENTER", UIParent, "BOTTOMLEFT", x*rX, y*rY)
--]]
----------------------------------------
-- copy a table and all its subtables --
----------------------------------------
local function tcopy(intable,outtable,overwrite,written)
	--written is an internal table to track references to already copied tables and keep those intact
	--create outtable if it doesn't exist
	outtable = outtable or {}
	--create written if this is the first call (user call)
	written = written or {}
	--add copied table to written
	written[tostring(intable)] = outtable
	--loop through data
	for key, data in pairs(intable) do
		--if overwrite or not exists, write value
		if (not outtable[key]) or overwrite then
			if type(data) == "table" then
				outtable[key] = written[tostring(data)] or tcopy(data,nil,nil,written)
			else
				outtable[key] = data
			end
		end
	end
	return outtable
end

local L = LibStub("AceLocale-3.0"):GetLocale("CCAssign")
BINDING_HEADER_CCASSIGN = "CCAssign"
BINDING_NAME_CCASSIGN_SHOW = L["Show CCAssign target select"]
local OneRingLib = OneRingLib
local ringID
local addon = CreateFrame("Frame", "CCAssign")
local cc_db = setmetatable({}, {__index=function(t,k) t[k] = {} return t[k] end})
local cc_by_lvl_class = setmetatable({}, {__index=function(t, class)
	t[class] = setmetatable({},{__index=function(ct, lvl)
		local cctbl = {}
		for key, value in pairs(cc_db[class]) do
			if (value.l <= lvl) then
				tinsert(cctbl, value)
			end
		end
		ct[lvl] = cctbl
		return cctbl
	end})
	return t[class]
end})
local mark_to_ringbtn ={
	[8]=1,
	[7]=2,
	[6]=4,
	[5]=8,
	[4]=7,
	[3]=6,
	[2]=5,
	[1]=3,
}
local mark_by_group_unit, group_unit_by_mark = {}, {}
local name_to_mark = {}
local cc_by_mark = {}
local uid_to_name = {}
for mark=1, 6 do cc_by_mark[mark] = {} end
local ringData
local function setraidtarget(_,raidtargetid)
	local rtable = ringData[mark_to_ringbtn[raidtargetid]]
	if UnitExists("target") and rtable.src and rtable.name then
		SendChatMessage(L["{rt%d} marked: %s (%s - %s)"]:format(raidtargetid, (UnitName("target")), rtable.name, rtable.src), "PARTY")
	end
	SetRaidTarget("target", raidtargetid)
end
ringData={
	name="CC Assign",
	hotkey="SHIFT+C",
	[1]={"func", setraidtarget, 8, r=1,g=1,b=1,icon="Interface\\TargetingFrame\\UI-RaidTargetingIcon_8",caption=L["Kill target"],},
	[2]={"func", setraidtarget, 7, r=1,g=0,b=0,icon="Interface\\TargetingFrame\\UI-RaidTargetingIcon_7",caption=L["Secondary target"],},
	[3]={"func", setraidtarget, 1, r=1, g=1, b=0, icon="Interface\\TargetingFrame\\UI-RaidTargetingIcon_1",caption=L["Mark target with: %s"]:format(RAID_TARGET_1),},
	[4]={"func", setraidtarget, 6, r=0.20, g=0.20, b=1, icon="Interface\\TargetingFrame\\UI-RaidTargetingIcon_6",caption=L["Mark target with: %s"]:format(RAID_TARGET_6),},
	[5]={"func", setraidtarget, 2, r=1, g=0.5, b=0.05, icon="Interface\\TargetingFrame\\UI-RaidTargetingIcon_2",caption=L["Mark target with: %s"]:format(RAID_TARGET_2),},
	[6]={"func", setraidtarget, 3, r=1, g=0.30, b=1, icon="Interface\\TargetingFrame\\UI-RaidTargetingIcon_3",caption=L["Mark target with: %s"]:format(RAID_TARGET_3),},
	[7]={"func", setraidtarget, 4, r=0.20, g=1, b=0.20, icon="Interface\\TargetingFrame\\UI-RaidTargetingIcon_4",caption=L["Mark target with: %s"]:format(RAID_TARGET_4),},
	[8]={"func", setraidtarget, 5, r=0.65, g=0.84, b=1, icon="Interface\\TargetingFrame\\UI-RaidTargetingIcon_5",caption=L["Mark target with: %s"]:format(RAID_TARGET_5),},
}
local function ring_update(t)
	if addon.opt.mode == 1 then -- opie compability
		OneRingLib:SetRingData(ringID,tcopy(t))
	else
		addon.buttonframe:ParseRingData(tcopy(t))
	end
	ringData = tcopy(t)
end
local eRingData = tcopy(ringData)
local sortfnc = function(a,b)
	return a.p < b.p
end

local cp = GetCursorPosition
local rel = UIParent:GetScale()
local function GetCursorPosition()
	local x,y = cp()
	return x/rel,y/rel
end

addon.buttonframe = CreateFrame("Frame")
addon.buttonframe:SetSize(150,150)
addon.buttonframe:SetScript("OnShow", function(self)
	self:ClearAllPoints()
	if addon.opt.modes[0].stickCursor then
		self:SetPoint("CENTER", UIParent, "BOTTOMLEFT", GetCursorPosition())
	else
		self:SetPoint("CENTER")
	end
end)
addon.buttonframe:Hide()
addon.buttonframe.buttons = {}
local points={"TOP", "TOPRIGHT", "RIGHT", "BOTTOMRIGHT", "BOTTOM", "BOTTOMLEFT", "LEFT", "TOPLEFT"}
for button=1, 8 do
	local b = CreateFrame("Button", nil, addon.buttonframe)
	b:SetSize(50,50)
	addon.buttonframe.buttons[button] = b
	b:SetPoint(points[button])
	b:SetID(button)
	b:SetScript("OnClick", function(self)
		if (not self.func) or (not self.arg) then return end
		self.func(1, self.arg)
		addon.buttonframe:Hide()
	end)
	b:SetScript("OnEnter", function(self)
		if not self.tooltip then return end
		GameTooltip:ClearAllPoints()
		GameTooltip:ClearLines()
		GameTooltip:SetOwner(self, "ANCHOR_NONE")
		GameTooltip:AddLine(self.tooltip,1,1,1)
		GameTooltip:Show()
	end)
	b:SetScript("OnLeave", function(self)
		GameTooltip:Hide()
	end)
	b:SetBackdrop({
		edgeFile="Interface\\Tooltips\\UI-Tooltip-Border",
		edgeSize=16,
	})
	b:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square")
end
addon.buttonframe.hide = CreateFrame("Button", nil, addon.buttonframe, "UIPanelCloseButton")
addon.buttonframe.hide:SetSize(50,50)
addon.buttonframe.hide:SetPoint("CENTER")
function addon.buttonframe:ParseRingData(dataTable)
	for bID=1,8 do
		local b = self.buttons[bID]
		local r = dataTable[bID]
		b.func = r[2]
		b.arg = r[3]
		b:SetBackdropBorderColor(r.r or 1, r.g or 1, r.b or 1)
		b:SetNormalTexture(r.icon)
		b.tooltip = r.caption
	end
end

function addon:UpdateRing()
	if (GetNumRaidMembers() > 0) or (GetNumPartyMembers()<=0) or (not UnitIsEnemy("player", "target")) then ring_update(eRingData) return end
	
	local targetType = UnitCreatureType("target")
	local ringdata = ringData
	for rtID=1, 6 do
		local cc_src = uid_to_name[group_unit_by_mark[rtID]]
		local cc_name, cc_icon
		if cc_src then
			table.sort(cc_by_mark[rtID], sortfnc)
			for _, data in ipairs(cc_by_mark[rtID]) do
				if data.t[targetType] then
					if type(data.n) == "number" then
						data.n = GetSpellInfo(data.n)
					end
					cc_name, cc_icon = data.n, data.i
					break
				end
			end
		end
		local r = ringdata[mark_to_ringbtn[rtID]]
		if (cc_name and cc_icon) then
			r.icon = cc_icon
			r.caption = L["Mark for %s to %s"]:format(cc_src, cc_name)
			r.src, r.name = cc_src, cc_name
		else
			local odata = eRingData[mark_to_ringbtn[rtID]]
			r.src = nil
			r.name = nil
			r.icon = odata.icon
			r.caption = odata.caption
		end
	end
	ring_update(ringdata)
	collectgarbage()
end
function addon:FetchGroup()
	table.wipe(mark_by_group_unit)
	table.wipe(group_unit_by_mark)
	table.wipe(cc_by_mark)
	table.wipe(uid_to_name)
	if GetNumRaidMembers() > 0 then return end
	local newmarks = {}
	local marks = {1,2,3,4,5,6}
	for i=1, GetNumPartyMembers() do
		local n = UnitName("party"..i)
		if name_to_mark[n] then
			for c, v in ipairs(marks) do
				if v == name_to_mark[n] then
					tremove(marks, c)
					break
				end
			end
			mark_by_group_unit["party"..i] = name_to_mark[n]
			group_unit_by_mark[name_to_mark[n]] = "party"..i
		else
			tinsert(newmarks, i)
		end
	end
	for _, pid in ipairs(newmarks) do
		local n = UnitName("party"..pid)
		local r = math.random(1, #marks)
		mark_by_group_unit["party"..pid] = marks[r]
		group_unit_by_mark[marks[r]] = "party"..pid
		tremove(marks, r)
	end
	table.wipe(name_to_mark)
	for pid=1, GetNumPartyMembers() do
		local n, r = UnitName("party"..pid)
		name_to_mark[n] = mark_by_group_unit["party"..pid]
		uid_to_name["party"..pid]=n
		cc_by_mark[mark_by_group_unit["party"..pid]] = tcopy(cc_by_lvl_class[(select(2, UnitClass("party"..pid)))][UnitLevel("party"..pid)])
		local whispername = n..(r and (strlen(r)>0) and "-"..r or "")
		SendChatMessage(L["<CC Assign> You have been assigned raid target icon {rt%d} (%s)"]:format(mark_by_group_unit["party"..pid], _G["RAID_TARGET_"..mark_by_group_unit["party"..pid]]),"WHISPER",nil,whispername)
	end
	if GetNumPartyMembers() > 0 then
		SendChatMessage(L["<CC Assign> The main kill order is as follows: %s ({rt8}) over %s ({rt7}). Individual assignments for crowd control have been whispered to players."]:format(RAID_TARGET_8, RAID_TARGET_7),"PARTY")
	end
	addon:UpdateRing()
end
function addon:RegisterCC(classString, levelGained, targetTypes, texture, nameId, priority)
	print("CC registered for "..classString..", gained at level "..levelGained..", using this texture: |T"..texture..":14|t")
	print("Enemy types affected:")
	for key in pairs(targetTypes) do
		print(key)
	end
	tinsert(cc_db[classString], {l=levelGained, t=targetTypes, i=texture, n=GetSpellInfo(nameId) or nameId, p=priority})
	table.wipe(cc_by_lvl_class[classString])
end
if OneRingLib then
	ringID = OneRingLib:CreateRing("CCAssign", ringData)
end
addon.buttonframe:ParseRingData(ringData)
function addon:BindRing(key)
	OneRingLib:SetRingBinding(ringID, key)
end
addon:SetScript("OnEvent", function(self, event, ...)
	local arg = {...}
	if event == "ADDON_LOADED" and arg[1] == "CCAssign" then
		self:UnregisterEvent("ADDON_LOADED")
		self.db = LibStub("AceDB-3.0"):New("CCAssign_DB", self.defaults or {})
		self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileEnable")
		self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileEnable")
		self.db.RegisterCallback(self, "OnProfileReset", "OnProfileEnable")
		self.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
		self.options.args.profiles.order = -1
		LibStub("AceConfig-3.0"):RegisterOptionsTable("CCAssign", self.options)
		self.opt = self.db.profile
		if self.opt.mode == 1 and not IsAddOnLoaded("OPie") then
			self.opt.mode = 0
		end
		return
	end
	if event == "PLAYER_TARGET_CHANGED" then
		self:UpdateRing()
		return
	end
	if event == "PARTY_MEMBERS_CHANGED" then
		if IsControlKeyDown() then
			self:FetchGroup()
		end
		return
	end
end)
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("PLAYER_TARGET_CHANGED")
addon:RegisterEvent("PARTY_MEMBERS_CHANGED")

-- GLOBALS: SLASH_CCASSIGN1
SlashCmdList["CCASSIGN"]=function(i)
	if i:lower():find("fetch") then
		addon:FetchGroup()
	else
		LibStub("AceConfigDialog-3.0"):Open("CCAssign")
	end
end
SLASH_CCASSIGN1 = "/ccassign"